'use strict';

var vutils = require('@visactor/vutils');
var segContext = require('../seg-context.js');
var enums = require('../enums.js');

function genCurveSegments(path, points) {
  let defined0 = !1;
  for (let i = 0, n = points.length; i <= n; i++) i >= n === defined0 && ((defined0 = !defined0) ? path.lineStart() : path.lineEnd()), defined0 && path.point(points[i]);
}
function genSegContext(curveType, direction, points) {
  const curveDirection = null != direction ? direction : vutils.abs(points[points.length - 1].x - points[0].x) > vutils.abs(points[points.length - 1].y - points[0].y) ? enums.Direction.ROW : enums.Direction.COLUMN;
  return "monotoneY" === curveType ? new segContext.ReflectSegContext(curveType, curveDirection) : new segContext.SegContext(curveType, curveDirection);
}

exports.genCurveSegments = genCurveSegments;
exports.genSegContext = genSegContext;
