'use strict';

var common = require('./common.js');
var linear = require('./linear.js');

class LinearClosed extends linear.Linear {
  lineEnd() {
    this.context.closePath();
  }
}
function genLinearClosedSegments(points) {
  let params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  const {
    direction: direction,
    startPoint: startPoint
  } = params;
  if (points.length < 2 - Number(!!startPoint)) return null;
  const segContext = common.genSegContext("linear", direction, points);
  return genLinearClosedTypeSegments(new LinearClosed(segContext, startPoint), points), segContext;
}
function genLinearClosedTypeSegments(path, points) {
  return common.genCurveSegments(path, points);
}

exports.LinearClosed = LinearClosed;
exports.genLinearClosedSegments = genLinearClosedSegments;
exports.genLinearClosedTypeSegments = genLinearClosedTypeSegments;
