'use strict';

var vutils = require('@visactor/vutils');

function textAttributesToStyle(attrs) {
  const style = {},
    parsePxValue = value => /^\d+(\.\d+)?$/.test(`${value}`) ? `${value}px` : `${value}`;
  return ["textAlign", "fontFamily", "fontVariant", "fontStyle", "fontWeight"].forEach(key => {
    attrs[key] && (style[vutils.lowerCamelCaseToMiddle(key)] = attrs[key]);
  }), ["fontSize", "lineHeight"].forEach(key => {
    const styleKey = vutils.lowerCamelCaseToMiddle(key);
    vutils.isNil(attrs[key]) || (style[styleKey] = parsePxValue(attrs[key]));
  }), vutils.isValid(attrs.maxLineWidth) && (style["max-width"] = parsePxValue(attrs.maxLineWidth)), attrs.underline ? style["text-decoration"] = "underline" : attrs.lineThrough && (style["text-decoration"] = "line-through"), attrs.fill && vutils.isString(attrs.fill) && (style.color = attrs.fill), style;
}

exports.textAttributesToStyle = textAttributesToStyle;
