import { genSegContext, genCurveSegments } from './common.js';
import { Linear } from './linear.js';

class LinearClosed extends Linear {
  lineEnd() {
    this.context.closePath();
  }
}
function genLinearClosedSegments(points) {
  let params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  const {
    direction: direction,
    startPoint: startPoint
  } = params;
  if (points.length < 2 - Number(!!startPoint)) return null;
  const segContext = genSegContext("linear", direction, points);
  return genLinearClosedTypeSegments(new LinearClosed(segContext, startPoint), points), segContext;
}
function genLinearClosedTypeSegments(path, points) {
  return genCurveSegments(path, points);
}

export { LinearClosed, genLinearClosedSegments, genLinearClosedTypeSegments };
