import { lowerCamelCaseToMiddle, isNil, isValid, isString } from '@visactor/vutils';

function textAttributesToStyle(attrs) {
  const style = {},
    parsePxValue = value => /^\d+(\.\d+)?$/.test(`${value}`) ? `${value}px` : `${value}`;
  return ["textAlign", "fontFamily", "fontVariant", "fontStyle", "fontWeight"].forEach(key => {
    attrs[key] && (style[lowerCamelCaseToMiddle(key)] = attrs[key]);
  }), ["fontSize", "lineHeight"].forEach(key => {
    const styleKey = lowerCamelCaseToMiddle(key);
    isNil(attrs[key]) || (style[styleKey] = parsePxValue(attrs[key]));
  }), isValid(attrs.maxLineWidth) && (style["max-width"] = parsePxValue(attrs.maxLineWidth)), attrs.underline ? style["text-decoration"] = "underline" : attrs.lineThrough && (style["text-decoration"] = "line-through"), attrs.fill && isString(attrs.fill) && (style.color = attrs.fill), style;
}

export { textAttributesToStyle };
